//+------------------------------------------------------------------+
//|                                                  CartoonBar1.mq4 |
//|                                       http://www.fxfisherman.com |
//+------------------------------------------------------------------+
#property copyright "scorpion@fxfisherman.com"
#property link      "http://www.fxfisherman.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
//---- input parameters
extern int       NumBars=500;
extern int       Pips=20;
extern string    Point1="high";
extern string    Point2="low";
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  Comment("Cartoons Bar 1.0");
  int    counted_bars=IndicatorCounted();

  int abrs=0;
  double    val1=0;
  double    val2=0;
  int       shift=0;

  if (Bars < NumBars) abrs = Bars - 11; else abrs = NumBars - 11;
  
  shift=abrs;

  while(shift>=0)
  {
    val1 = GetValue(Point1, shift);
    val2 = GetValue(Point2, shift);
    if(MathAbs(val1 - val2) >= Pips * Point())
    {
      val2 = High[shift];
      val1 = Low[shift];
    }else{
      val2 = Low[shift];
      val1 = Low[shift];
    }

    ExtMapBuffer1[shift]=val1;
    ExtMapBuffer2[shift]=val2;

    shift--;
  }

   return(0);
}
//+------------------------------------------------------------------+


double GetValue(string price_type, int index)
{
  if(price_type=="high")
  {
    return(High[index]);
  }else if(price_type=="low"){
    return(Low[index]);
  }else if(price_type=="open"){
    return(Open[index]);
  }else if(price_type=="close"){
    return(Close[index]);
  }
}